var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var list_exports = {};
__export(list_exports, {
  list: () => list
});
module.exports = __toCommonJS(list_exports);
var import_utils = require("@nocobase/utils");
var import_utils2 = require("../utils");
var import_constants = require("../constants");
var import_sequelize = require("sequelize");
function totalPage(total, pageSize) {
  return Math.ceil(total / pageSize);
}
__name(totalPage, "totalPage");
function findArgs(ctx) {
  var _a;
  const resourceName = ctx.action.resourceName;
  const params = ctx.action.params;
  if (params.tree) {
    const [collectionName, associationName] = resourceName.split(".");
    const collection = ctx.db.getCollection(resourceName);
    if (collection.options.tree && !(associationName && collectionName === collection.name)) {
      const foreignKey = ((_a = collection.treeParentField) == null ? void 0 : _a.foreignKey) || "parentId";
      (0, import_utils.assign)(params, { filter: { [foreignKey]: null } }, { filter: "andMerge" });
    }
  }
  const { tree, fields, filter, appends, except, sort } = params;
  return { tree, filter, fields, appends, except, sort };
}
__name(findArgs, "findArgs");
async function listWithPagination(ctx) {
  var _a;
  const { page = import_constants.DEFAULT_PAGE, pageSize = import_constants.DEFAULT_PER_PAGE } = ctx.action.params;
  const repository = (0, import_utils2.getRepositoryFromParams)(ctx);
  const resourceName = ctx.action.resourceName;
  const collection = ctx.db.getCollection(resourceName);
  const options = {
    context: ctx,
    ...findArgs(ctx),
    ...(0, import_utils2.pageArgsToLimitArgs)(parseInt(String(page)), parseInt(String(pageSize)))
  };
  Object.keys(options).forEach((key) => {
    if (options[key] === void 0) {
      delete options[key];
    }
  });
  let filterTreeData = [];
  let filterTreeCount = 0;
  if (ctx.action.params.tree) {
    const foreignKey = ((_a = collection.treeParentField) == null ? void 0 : _a.foreignKey) || "parentId";
    const params = Object.values(options.filter).flat()[0] || {};
    let dataId;
    if (Object.entries(params).length) {
      const getParent = /* @__PURE__ */ __name(async (filter = {}) => {
        const data = await repository.findOne({
          filter
        });
        dataId = data.id;
      }, "getParent");
      await getParent(params);
      const query = `
        WITH RECURSIVE tree1 AS (
            SELECT id, "${foreignKey}"
            FROM ${collection.name}
            WHERE id = :dataId

            UNION ALL

            SELECT p.id, p."${foreignKey}"
            FROM tree1 up
            JOIN ${collection.name} p ON up."${foreignKey}" = p.id
        ),
        tree2 AS (
            SELECT id, "${foreignKey}"
            FROM ${collection.name}
            WHERE id = :dataId

            UNION ALL

            SELECT p.id, p."${foreignKey}"
            FROM tree2 down
            JOIN ${collection.name} p ON down.id = p."${foreignKey}"
        )
        SELECT DISTINCT *
        FROM (
          SELECT * 
          FROM tree1
          UNION ALL
          SELECT * 
          FROM tree2
      );`;
      const filterTreeDatas = await ctx.db.sequelize.query(query, {
        replacements: {
          dataId
        },
        type: import_sequelize.QueryTypes.SELECT
        // logging: console.log
      });
      const newRows = filterTreeDatas;
      const filterIds = newRows.map((item) => item.id);
      const where = {
        id: {
          [import_sequelize.Op.in]: filterIds
        }
      };
      const [rows2, count2] = await repository.findAndCount({
        filter: where,
        appends: options.appends || []
      });
      const _data = rows2.map((item) => item.dataValues);
      const father = _data.filter((parent) => parent.parentId === null);
      const transTreeData = /* @__PURE__ */ __name((father2, allRows) => {
        father2.forEach((parent, index) => {
          var _a2;
          const children = allRows.filter((child) => child.parentId === parent.id);
          const i = index.toString();
          parent.__index = parent.father || parent.father == "0" ? parent.father + ".children." + i : i;
          if (children == null ? void 0 : children.length) {
            const transChild = children.map((child) => {
              return {
                ...child,
                father: parent.__index
              };
            });
            parent.children = transChild;
          }
          if ((_a2 = parent.children) == null ? void 0 : _a2.length) {
            transTreeData(parent.children, allRows);
          }
        });
      }, "transTreeData");
      transTreeData(father, _data);
      filterTreeData = father;
      filterTreeCount = count2;
    }
  }
  const [rows, count] = await repository.findAndCount(options);
  ctx.body = {
    count: filterTreeData.length ? filterTreeCount : count,
    rows: filterTreeData.length ? filterTreeData : rows,
    page: Number(page),
    pageSize: Number(pageSize),
    totalPage: totalPage(count, pageSize)
  };
}
__name(listWithPagination, "listWithPagination");
async function listWithNonPaged(ctx) {
  const repository = (0, import_utils2.getRepositoryFromParams)(ctx);
  const rows = await repository.find({ context: ctx, ...findArgs(ctx) });
  ctx.body = rows;
}
__name(listWithNonPaged, "listWithNonPaged");
async function list(ctx, next) {
  const { paginate } = ctx.action.params;
  if (paginate === false || paginate === "false") {
    await listWithNonPaged(ctx);
    ctx.paginate = false;
  } else {
    await listWithPagination(ctx);
    ctx.paginate = true;
  }
  await next();
}
__name(list, "list");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  list
});
